<script setup>
import {ref} from "vue";

const props = defineProps(['user']);
const u = props.user;
const WRITER = "WRITER";
const SPEAKER = "SPEAKER";
const ASSISTANT = "ASSISTANT";

const course = ref(null);

const user = ref({
  firstName: u.firstName,
  lastName: u.lastName,
  email: u.email,
  section: u.section,
  sectionYear: u.sectionYear,
  telegram: u.telegram,
  discord: u.discord,
  showMessage: false,//NOT PART
  motivationMessage: u.motivationMessage,
  wantedRoles: u.wantedRoles,
  personalNotes: u.personalNotes,
  selectedRoles: u.selectedRoles,
  selectedRolesAlert: u.selectedRolesAlert,
  currentRoles: u.currentRoles
});

function tinyLabel(option) {
  switch (option) {
    case WRITER:
      return "C";
    case SPEAKER:
      return "S";
    case ASSISTANT:
      return "A";
  }
}

</script>

<template>
  <tr class="bg-s4s-redwood-600 border-b hover:bg-gray-50">
    <!--    Show candidate name, email and section-->
    <th scope="row" class="flex items-center px-6 py-4 font-medium text-gray-900 whitespace-nowrap">
      <div class="ps-3">
        <div class="text-base font-semibold">{{ user.firstName + " " + user.lastName }}</div>
        <div class="font-normal text-gray-500">{{ user.email }}</div>
        <div class="font-normal text-gray-500">
          {{
            (user.section == null) ? "" : (user.section + ((user.sectionYear == null) ? "" : ("-" + user.sectionYear)))
          }}
        </div>
      </div>
    </th>
    <!--    Show candidate telegram and discord-->
    <td class="px-6 py-4">
      <div class="ps-3">
        <div class="font-normal text-gray-500" v-if="user.telegram !== null">Telegram: {{ user.telegram }}</div>
        <div class="font-normal text-gray-500" v-if="user.discord !== null">Discord: {{ user.discord }}</div>
      </div>
    </td>
    <!--    Show candidate's motivation message-->
    <td class="px-6 py-4">
      <button @click="() => user.showMessage = !user.showMessage"
              class="font-medium text-blue-600 hover:underline">
        <span v-if="user.showMessage">Fermer</span>
        <span v-else>Ouvrir</span>
      </button>
      <br>
      <div v-if="user.showMessage">
        <div>
          {{ user.motivationMessage }}
        </div>
      </div>
    </td>
    <!--    Show candidate's wanted roles for all courses-->
    <td class="px-6 py-4" style="width: 10%">
      <div class="p-2.5">
        <span v-for="(value, key) in user.wantedRoles">
            <b>{{ key }} :</b>
            {{ value.map(e => tinyLabel(e)).join("") }}<br>
        </span>
      </div>
    </td>
    <!--    Show personal notes-->
    <td class="px-6 py-4">
      <textarea v-model="user.personalNotes"/>
      <button @click="saveChoices">Enregister le text</button>
    </td>
  </tr>
</template>
<style scoped>
</style>